<?php

namespace App\Classes\Modules\Vouchers\DataTransferObjects;


use App\Classes\General\Interfaces\DataTransferObject;
use App\Models\User;

class CreateVoucherifyOrderObject implements DataTransferObject
{
    /** @var User  */
    private $employee;

    /** @var int */
    private $companyId;

    /** @var int */
    private $transactionId;

    /** @var float */
    private $amount;

    /** @var bool */
    private $isNoVoucher;

    /** @var bool */
    private $isTopUpWallet;

    /**
     * CreateVoucherifyOrderObject constructor.
     * @param User $employee
     * @param int $companyId
     * @param int $transactionId
     * @param float $amount
     * @param bool $isNoVoucher
     * @param bool $isTopUpWallet
     */
    public function __construct(User $employee, int $companyId, int $transactionId, float $amount, bool $isNoVoucher, bool $isTopUpWallet)
    {
        $this->employee = $employee;
        $this->companyId = $companyId;
        $this->transactionId = $transactionId;
        $this->amount = $amount;
        $this->isNoVoucher = $isNoVoucher;
        $this->isTopUpWallet = $isTopUpWallet;
    }

    /**
     * @return int
     */
    public function getCompanyId(): int
    {
        return $this->companyId;
    }

    /**
     * @return int
     */
    public function getTransactionId(): int
    {
        return $this->transactionId;
    }

    /**
     * @return float
     */
    public function getAmount(): float
    {
        return $this->amount;
    }

    /**
     * @return User
     */
    public function getEmployee(): User
    {
        return $this->employee;
    }

    /**
     * @return bool
     */
    public function getIsNoVoucher(): bool
    {
        return $this->isNoVoucher;
    }

    /**
     * @return bool
     */
    public function getIsTopUpWallet(): bool
    {
        return $this->isTopUpWallet;
    }
}
